import React, { Component } from 'react';
import 'bootstrap/dist/css/bootstrap.css';

function _inheritsLoose(subClass, superClass) {
  subClass.prototype = Object.create(superClass.prototype);
  subClass.prototype.constructor = subClass;
  subClass.__proto__ = superClass;
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

var TableFilter = /*#__PURE__*/function (_Component) {
  _inheritsLoose(TableFilter, _Component);

  function TableFilter(props) {
    var _this;

    _this = _Component.call(this, props) || this;
    _this.state = {
      search: ''
    };
    return _this;
  }

  var _proto = TableFilter.prototype;

  _proto.componentWillReceiveProps = function componentWillReceiveProps(nextProps, nextContext) {
    this.setState({
      search: nextProps.toChild.searchInput
    });
  };

  _proto.render = function render() {
    return /*#__PURE__*/React.createElement("div", {
      className: "row"
    }, /*#__PURE__*/React.createElement("div", {
      className: "col-3"
    }, /*#__PURE__*/React.createElement("select", {
      className: "form-control-sm form-control",
      onChange: this.props.changeRecordsPerPage.bind(this)
    }, /*#__PURE__*/React.createElement("option", {
      value: 10
    }, "10 records per page"), /*#__PURE__*/React.createElement("option", {
      value: 25
    }, "25 records per page"), /*#__PURE__*/React.createElement("option", {
      value: 50
    }, "50 records per page"), /*#__PURE__*/React.createElement("option", {
      value: 100
    }, "100 records per page"))), /*#__PURE__*/React.createElement("div", {
      className: "col-6"
    }), /*#__PURE__*/React.createElement("div", {
      className: "col-3 text-right padding_right"
    }, /*#__PURE__*/React.createElement("div", {
      className: "input-group input-group-sm"
    }, /*#__PURE__*/React.createElement("div", {
      className: "input-group-prepend"
    }, /*#__PURE__*/React.createElement("span", {
      className: "input-group-text"
    }, "Search")), /*#__PURE__*/React.createElement("input", {
      type: "text",
      className: "form-control remove-outline",
      value: this.state.search,
      onChange: this.props.search.bind(this)
    }))), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement("br", null));
  };

  return TableFilter;
}(Component);

var PagiNate = /*#__PURE__*/function (_Component) {
  _inheritsLoose(PagiNate, _Component);

  function PagiNate(props) {
    var _this;

    _this = _Component.call(this, props) || this;
    _this.state = {
      pageNate: [],
      skip: 10,
      length: 0,
      take: 0,
      pageNo: 0
    };
    _this.previous = _this.previous.bind(_assertThisInitialized(_this));
    _this.next = _this.next.bind(_assertThisInitialized(_this));
    return _this;
  }

  var _proto = PagiNate.prototype;

  _proto.componentWillReceiveProps = function componentWillReceiveProps(nextProps, nextContext) {
    var _this2 = this;

    this.setState({
      pagiNate: nextProps.pageNate,
      length: nextProps.pageNate.length,
      skip: nextProps.skip,
      take: nextProps.take
    }, function () {
      console.clear();
      console.log(_this2.state);

      _this2.setState({
        pageNo: _this2.state.skip / _this2.state.take + 1
      }, function () {
        console.log('PageNo :', _this2.state.pageNo);
      });
    });
  };

  _proto.previous = function previous(e) {
    var page = this.state.take - this.state.skip;
    this.props.paginateMethod.bind(e, this.state.skip - this.state.take);
    console.log('Previous: ', page);
  };

  _proto.next = function next(e) {
    var page = this.state.take + this.state.skip;
    console.log('Next: ', page);
    this.props.paginateMethod.bind(e, this.state.take + this.state.skip);
  };

  _proto.render = function render() {
    var showingUpTo = 0;

    if (this.state.skip + this.state.take >= this.props.totalTableData) {
      showingUpTo = this.props.totalTableData;
    } else {
      showingUpTo = this.state.skip + this.state.take;
    }

    return /*#__PURE__*/React.createElement("div", {
      className: "row"
    }, /*#__PURE__*/React.createElement("div", {
      className: "col-6"
    }, "Showing ", this.state.skip + 1, " to ", showingUpTo, " of ", this.props.totalTableData, " entries"), /*#__PURE__*/React.createElement("div", {
      className: "col-6 text-right justify-content-end pull-right"
    }, /*#__PURE__*/React.createElement("nav", {
      className: "",
      "aria-label": "Page navigation example text-right"
    }, /*#__PURE__*/React.createElement("ul", {
      className: "pagination justify-content-end"
    }, this.state.pageNo === 1 && /*#__PURE__*/React.createElement("li", {
      className: "page-item disabled"
    }, /*#__PURE__*/React.createElement("a", {
      href: "javascript:void(0);",
      className: "page-link",
      "aria-label": "Previous"
    }, /*#__PURE__*/React.createElement("span", {
      "aria-hidden": "true"
    }, "\xAB"), /*#__PURE__*/React.createElement("span", {
      className: "sr-only"
    }, "Previous"))), this.state.pageNo !== 1 && /*#__PURE__*/React.createElement("li", {
      className: "page-item"
    }, /*#__PURE__*/React.createElement("a", {
      href: "javascript:void(0);",
      className: "page-link",
      "aria-label": "Previous"
    }, /*#__PURE__*/React.createElement("span", {
      "aria-hidden": "true"
    }, "\xAB"), /*#__PURE__*/React.createElement("span", {
      className: "sr-only"
    }, "Previous"))), this.state.pageNo === this.state.length && /*#__PURE__*/React.createElement("li", {
      className: "page-item disabled"
    }, /*#__PURE__*/React.createElement("a", {
      href: "javascript:void(0);",
      className: "page-link",
      "aria-label": "Next"
    }, /*#__PURE__*/React.createElement("span", {
      "aria-hidden": "true"
    }, "\xBB"), /*#__PURE__*/React.createElement("span", {
      className: "sr-only"
    }, "Next"))), this.state.pageNo !== this.state.length && /*#__PURE__*/React.createElement("li", {
      className: "page-item"
    }, /*#__PURE__*/React.createElement("a", {
      href: "javascript:void(0);",
      className: "page-link",
      "aria-label": "Next"
    }, /*#__PURE__*/React.createElement("span", {
      "aria-hidden": "true"
    }, "\xBB"), /*#__PURE__*/React.createElement("span", {
      className: "sr-only"
    }, "Next")))))));
  };

  return PagiNate;
}(Component);

var ReactDataTable = /*#__PURE__*/function (_Component) {
  _inheritsLoose(ReactDataTable, _Component);

  function ReactDataTable(props) {
    var _this;

    _this = _Component.call(this, props) || this;
    _this.state = {
      columns: [],
      apiData: [],
      pageNate: [],
      take: 10,
      skip: 0,
      searchInput: '',
      totalTableData: 0
    };
    _this.paginate = _this.paginate.bind(_assertThisInitialized(_this));
    _this.changeRecordsPerPage = _this.changeRecordsPerPage.bind(_assertThisInitialized(_this));
    _this.search = _this.search.bind(_assertThisInitialized(_this));
    _this.onAction = _this.onAction.bind(_assertThisInitialized(_this));
    _this.changeOrder = _this.changeOrder.bind(_assertThisInitialized(_this));
    return _this;
  }

  var _proto = ReactDataTable.prototype;

  _proto.componentDidMount = function componentDidMount() {
    var _this2 = this;

    console.log('props: ', this.props.dataTablesOptions);
    this.setState({
      columns: this.props.dataTablesOptions.colums,
      apiData: this.props.dataTableData.data,
      pageNate: this.props.dataTableData.pageNate,
      totalTableData: this.props.dataTableData.totalTableData
    }, function () {
      _this2.props.dataTableOnChange(_this2.state);
    });
  };

  _proto.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    this.setState({
      columns: nextProps.dataTablesOptions.colums,
      apiData: nextProps.dataTableData.data,
      pageNate: nextProps.dataTableData.pageNate,
      totalTableData: nextProps.dataTableData.totalTableData
    });
  };

  _proto.changeOrder = function changeOrder(col, e) {
    this.props.dataTableOnChange(this.state);
  };

  _proto.paginate = function paginate(skip, e) {
    var _this3 = this;

    this.setState({
      skip: skip
    }, function () {
      _this3.props.dataTableOnChange(_this3.state);
    });
  };

  _proto.changeRecordsPerPage = function changeRecordsPerPage(e) {
    var _this4 = this;

    this.setState({
      take: e.target.value
    }, function () {
      _this4.props.dataTableOnChange(_this4.state);
    });
  };

  _proto.search = function search(e) {
    var _this5 = this;

    console.log(e.target.value);
    this.setState({
      searchInput: e.target.value
    }, function () {
      _this5.props.dataTableOnChange(_this5.state);
    });
  };

  _proto.onAction = function onAction(e) {
    console.log('You have clicked record no: ');
  };

  _proto.render = function render() {
    var _this6 = this;

    return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(TableFilter, {
      onAction: this.onAction,
      search: this.search,
      searchInput: this.state.searchInput,
      changeRecordsPerPage: this.changeRecordsPerPage,
      filterId: this.state.filterId,
      toChild: this.state
    }), /*#__PURE__*/React.createElement("table", {
      className: "table table-hover"
    }, /*#__PURE__*/React.createElement("thead", null, /*#__PURE__*/React.createElement("tr", null, this.state.columns.map(function (item, index) {
      if (item.show === true && item.button.show === false) {
        if (item.order === true) {
          return /*#__PURE__*/React.createElement("th", {
            width: item.width,
            scope: "col",
            key: index
          }, item.title, /*#__PURE__*/React.createElement("a", {
            href: "#",
            onClick: _this6.changeOrder.bind(_this6, item.name)
          }, " \xA0", /*#__PURE__*/React.createElement("i", {
            className: "fa fa-sort ",
            "aria-hidden": "true"
          })));
        } else {
          return /*#__PURE__*/React.createElement("th", {
            width: item.width,
            scope: "col",
            key: index
          }, item.title);
        }
      } else if (item.show === true && item.button.show === true) {
        return /*#__PURE__*/React.createElement("th", {
          width: item.width,
          scope: "col",
          key: index
        }, item.title, " ", item.order ? /*#__PURE__*/React.createElement("a", {
          href: "#",
          onClick: _this6.changeOrder.bind(_this6, item.name)
        }, /*#__PURE__*/React.createElement("i", {
          className: "fa fa-sort ",
          "aria-hidden": "true"
        })) : /*#__PURE__*/React.createElement(Fragment, null));
      } else if (item.show === false && item.button.show === true) {
        return /*#__PURE__*/React.createElement("th", {
          width: item.width,
          scope: "col",
          key: index
        }, item.button.title);
      }
    }))), /*#__PURE__*/React.createElement("tbody", null, this.state.apiData.map(function (item, index) {
      return /*#__PURE__*/React.createElement("tr", null, _this6.state.columns.map(function (cols, count) {
        for (var i = 0; i < _this6.state.columns.length; i++) {
          if (cols.name === Object.keys(item)[i]) {
            if (cols.show === true && cols.button.show === true) {
              return /*#__PURE__*/React.createElement("td", null, item[cols.name], /*#__PURE__*/React.createElement("button", {
                type: "button",
                event: item,
                id: item.id,
                name: cols.name,
                onClick: _this6.props.dataTableBtnAction.bind(_this6, item[cols.button.passValue], cols.button.actionType),
                className: "btn btn-primary"
              }, cols.button.title));
            } else if (cols.show === true && cols.button.show === false) {
              return /*#__PURE__*/React.createElement("td", null, item[cols.name]);
            }
          }

          if (cols.show === false && cols.button.show === true) {
            return /*#__PURE__*/React.createElement("td", null, /*#__PURE__*/React.createElement("button", {
              type: "button",
              event: item,
              id: item.id,
              name: cols.name,
              onClick: _this6.props.dataTableBtnAction.bind(_this6, item[cols.button.passValue], cols.button.actionType),
              className: "btn btn-primary"
            }, cols.button.title));
          }
        }
      }));
    }))), /*#__PURE__*/React.createElement(PagiNate, {
      paginateMethod: this.paginate,
      pageNate: [1, 2, 3, 4, 5],
      skip: this.state.skip,
      take: this.state.take,
      totalTableData: this.state.totalTableData
    }));
  };

  return ReactDataTable;
}(Component);

export default ReactDataTable;
//# sourceMappingURL=index.modern.js.map
